<template>
  <div class="app-container">
    <div ref="topContainerRef">
      <TableSearch
        :queryParams="queryParams"
        :showSearch="showSearch"
        label-width="90px"
        queryRef="queryRef"
        @refresh="resetQuery"
        @search="handleQuery"
      >
        <template #one>
          <el-col :lg="6" :md="12" :sm="24" :xl="6" :xs="24" :xxl="6">
            <el-form-item label="点位名称" prop="waypointName">
              <el-input
                v-model="queryParams.waypointName"
                clearable
                placeholder="请输入点位名称"
                style="width: 100%"
                @keyup.enter="handleQuery"
              />
            </el-form-item>
          </el-col>
          <el-col :lg="6" :md="12" :sm="24" :xl="6" :xs="24" :xxl="6">
            <el-form-item label="所属地图" prop="mapId">
              <el-select
                v-model="queryParams.mapId"
                clearable
                placeholder="请选择所属地图"
                style="width: 100%"
              >
                <el-option
                  v-for="item in mapList"
                  :key="item.id"
                  :label="item.mapName"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :lg="6" :md="12" :sm="24" :xl="6" :xs="24" :xxl="6">
            <el-form-item label="启用状态" prop="enabled">
              <el-select
                v-model="queryParams.enabled"
                clearable
                placeholder="请选择启用状态"
                style="width: 100%"
              >
                <el-option label="启用" value="0" />
                <el-option label="禁用" value="1" />
              </el-select>
            </el-form-item>
          </el-col>
        </template>
      </TableSearch>

      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            icon="Plus"
            plain
            type="primary"
            @click="handleAdd"
            >新增
          </el-button>
        </el-col>
        <right-toolbar
          v-model:showSearch="showSearch"
          @queryTable="getList"
        ></right-toolbar>
      </el-row>
    </div>

    <div :style="containerHeight">
      <el-table
        v-loading="loading"
        height="100%"
        :data="tableDataList"
      >
        <el-table-column
          align="center"
          label="id"
          prop="id"
          show-overflow-tooltip
        />
        <el-table-column
          align="center"
          label="点位名称"
          prop="waypointName"
          show-overflow-tooltip
        />
        <el-table-column
          align="center"
          label="所属地图"
          prop="mapName"
          show-overflow-tooltip
        />
        <el-table-column
          align="center"
          label="点位描述"
          prop="remark"
          show-overflow-tooltip
        />
        <el-table-column align="center" label="启用状态" prop="enabled">
          <template #default="scope">
            <el-switch
              v-model="scope.row.enabled"
              active-text="启用"
              active-value="0"
              inactive-text="禁用"
              inactive-value="1"
              inline-prompt
              @change="handleChange(scope.row)"
            />
          </template>
        </el-table-column>
        <el-table-column align="center" label="配置状态" prop="configStatus">
          <template #default="scope">
            <TableTags
              :options="[
                {
                  label: '已配置',
                  value: '0',
                  type: 'success',
                },
                {
                  label: '未配置',
                  value: '1',
                  type: 'warning',
                },
              ]"
              :value="scope.row.configStatus"
            ></TableTags>
          </template>
        </el-table-column>
        <el-table-column
          align="center"
          label="创建人"
          prop="createBy"
          show-overflow-tooltip
        />
        <el-table-column
          align="center"
          label="创建时间"
          prop="createTime"
          show-overflow-tooltip
        />
        <el-table-column
          align="center"
          class-name="small-padding fixed-width"
          label="操作"
          width="200"
        >
          <template #default="scope">
            <el-button
              icon="Edit"
              link
              type="primary"
              @click="handleUpdate(scope.row)"
            >
              修改
            </el-button>
            <el-button
              icon="Cpu"
              link
              type="primary"
              @click="handleDeploy(scope.row)"
              >配置
            </el-button>
            <el-button
              icon="Delete"
              link
              type="primary"
              @click="handleDelete(scope.row)"
              >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total > 0"
        v-model:limit="queryParams.pageSize"
        v-model:page="queryParams.pageNum"
        :total="total"
        @pagination="getList"
      />
    </div>

    <!-- 添加或修改检测项配置对话框 -->
    <el-dialog v-model="open" :title="title" append-to-body width="500px">
      <el-form ref="pointRef" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="点位名称" prop="waypointName">
          <el-input v-model="form.waypointName" placeholder="请输入点位名称" />
        </el-form-item>
        <el-form-item label="所属地图" prop="mapId">
          <el-select
            v-model="form.mapId"
            clearable
            placeholder="请选择所属地图"
            style="width: 100%"
          >
            <el-option
              v-for="item in mapList"
              :key="item.id"
              :label="item.mapName"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input
            v-model="form.remark"
            :rows="2"
            placeholder="请输入备注"
            type="textarea"
          />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>

  </div>
</template>

<script name="Detect" setup>
import {
  addPoint,
  deletePoint,
  getPointList,
  updatePoint,
} from "@/api/inspection/point";
import { getMapList } from "@/api/inspection/map";
import TableSearch from "@/components/TableSearch/index.vue";
import { listGroup } from "@/api/system/group.js";
import { appendParamsToPath } from "@/utils/fn.js";
import TableTags from "@/components/TableTags/index.vue";
import EditTable from "@/components/EditTable/index.vue";

import { useContainerHeight } from "@/hooks/tableHeight";
import { ElMessage, ElMessageBox } from "element-plus";
import { el } from "element-plus/es/locale/index.mjs";
import { map } from "lodash";

const topContainerRef = ref();
const containerHeight = useContainerHeight(topContainerRef);

const { proxy } = getCurrentInstance();

const tableDataList = ref([]);
const open = ref(false);
const loading = ref(false);
const showSearch = ref(true);

const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    waypointName: null,
    enabled: null,
    mapId: null,
  },
  rules: {
    waypointName: [
      { required: true, message: "点位名称不能为空", trigger: "blur" },
    ],
    mapId: [
      { required: true, message: "所属地图不能为空", trigger: "change" },
    ],
  },
});

const mapList = ref([]);
// 获取地图列表
const getMapArr = () => {
    getMapList({
        pageNum: 1,
        pageSize: 10000,
    }).then((response) => {
        mapList.value = response.rows;
    });
}

const { queryParams, form, rules } = toRefs(data);

/** 查询点位列表 */
function getList() {
  loading.value = true;
  getPointList(queryParams.value)
    .then((res) => {
      tableDataList.value = res.rows;
      total.value = res.total;
    })
    .finally(() => {
      loading.value = false;
    });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  pointRef.value.resetFields();
  form.value = {};
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  handleQuery();
}

/** 新增按钮操作 */
function handleAdd() {
  isNew.value = true;
  open.value = true;
  title.value = "添加点位";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  form.value = { ...row };
  isNew.value = false;
  open.value = true;
  title.value = "修改点位";
}

const pointRef = ref();
const isNew = ref(true);
/** 提交按钮 */
function submitForm() {
  pointRef.value.validate((valid) => {
    if (valid) {
      if (isNew.value) {
        addPoint(form.value).then(() => {
          ElMessage.success("添加成功");
          getList();
          open.value = false;
          reset();
        });
      } else {
        updatePoint(form.value).then(() => {
          ElMessage.success("修改成功");
          getList();
          open.value = false;
          reset();
        });
      }
    }
  }); 
}

/** 删除按钮操作 */
function handleDelete(row) {
  ElMessageBox.confirm("确定要删除该点位吗?", "提示", {
    confirmButtonText: "确定",
    cancelButtonText: "取消",
    type: "warning",
  }).then(() => {
    deletePoint(row.id).then(() => {
      ElMessage.success("删除成功");
      getList();
    });
  });
}

/** 配置按钮操作 */
function handleDeploy(row) {
  const params = { itemId: row.detectItemId, name: row.waypointName, state: row.status };
  const fullPath = appendParamsToPath("/flow", params);
  const p = window.open(fullPath, "_blank");
}



onMounted(() => {
  getList();
  getMapArr();
});

</script>
